{-------------------------------------------------------------------------------
Delphi Save And Restore
Copyright (C) 2009 ouiouioui contact@toutenvrac.org

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-------------------------------------------------------------------------------}
Program DelphiSaveAndRestore;

{$R 'DelphiSaveAndRestore.manifest.res' 'DelphiSaveAndRestore.manifest.rc'}
{$R 'skins.res' 'skins.rc'}
{$R 'updater.res' 'updater.rc'}

uses
  Windows,
  Forms,
  Main in 'Main.pas' {fmMain},
  uVistaFuncs in 'uVistaFuncs.pas',
  Utils in 'Utils.pas',
  MainFunctions in 'MainFunctions.pas',
  MainMsg in 'MainMsg.pas',
  ThreadUpdater in 'ThreadUpdater.pas',
  SelectRegKey in 'SelectRegKey.pas' {fmSelectRegKey},
  LogAction in 'LogAction.pas' {fmLogAction};

{$R *.res}

Var
  HMutexApp:   THandle;
  HWindowsApp: HWND;
  ErrorApp:    Integer;

Begin
{$IFDEF DEBUG}
  ReportMemoryLeaksOnShutDown := true; //si debug on affiche les problmes de libration de mmoire
{$ENDIF}
  SetLastError(NO_ERROR);
  HMutexApp := CreateMutex(NIL, False, 'Delphi Save And Restore');
  ErrorApp  := GetLastError;
  If (ErrorApp <> ERROR_ALREADY_EXISTS) And (ErrorApp <> ERROR_ACCESS_DENIED) Then
  Begin
    Application.Initialize;
    Application.MainFormOnTaskbar := True;
    Application.CreateForm(TfmMain, fmMain);
  Application.CreateForm(TfmLogAction, fmLogAction);
  Application.Run;
    CloseHandle(HMutexApp);
  End
  Else
  Begin
    HWindowsApp := FindWindow(NIL, PChar('Delphi Save And Restore'));
    ShowWindow(HWindowsApp, SW_RESTORE); { Restaurer l'application si minimise }
    SetForegroundWindow(HWindowsApp);    { Mettre la premire instance en premier plan : }
  End;
End.

