Unit LogAction;

Interface

Uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, JvComponentBase, JvFormPlacement;

Type
  TfmLogAction = Class(TForm)
    mLogAction:    TMemo;
    JvFormStorage: TJvFormStorage;
    Procedure FormShow(Sender: TObject);
    Procedure FormCanResize(Sender: TObject; Var NewWidth, NewHeight: Integer;
      Var Resize: Boolean);
  Public
    Procedure AddLog(Const sMsg: String);
  End;

Var
  fmLogAction: TfmLogAction;

Implementation

{$R *.dfm}

Uses
  Main;

Procedure TfmLogAction.FormCanResize(Sender: TObject; Var NewWidth,
  NewHeight: Integer; Var Resize: Boolean);
Begin
  If NewWidth < 539 Then
    NewWidth := 539;
  If NewHeight < 107 Then
    NewHeight := 107;
End;

Procedure TfmLogAction.FormShow(Sender: TObject);
Var
  Rect:   TRect;
  MinTop: Integer;
Begin
  SystemParametersInfo(SPI_GETWORKAREA, 0, @Rect, 0);
  MinTop := Screen.Height - (Screen.Height - Rect.Bottom) - fmMain.Height - Height;
  // on met dessous si sa passe
  If fmMain.Top <= MinTop Then
  Begin
    Top   := fmMain.Top + fmMain.Height;
    Left  := fmMain.Left;
    Width := fmMain.Width;
  End //sinon on essaye de mettre au dessus
  Else
  If fmMain.Top >= Height Then
  Begin
    Top   := fmMain.Top - Height;
    Left  := fmMain.Left;
    Width := fmMain.Width;
  End;
End;

Procedure TfmLogAction.AddLog(Const sMsg: String);
Begin
  mLogAction.Lines.Add(DateTimeToStr(Now) + ' : ' + sMsg);
End;

End.

